'use strict';

module.exports = function(grunt) {
  grunt.initConfig({
    jshint: {
      all: [
        'crispy-paginator.js',
        'crispy-paginator.spec.js',
      ],
      options: {
        jshintrc: '.jshintrc',
      },
    },
    ngtemplates: {
      all: {
        src: 'crispy-paginator.tpl.html',
        dest: 'templates.js',
        options: {
          standalone: true,
          module: 'crispy-paginator.templates',
        },
      },
    },
    jasmine: {
      src: [
        'crispy-paginator.js',
        'templates.js',
      ],
      options: {
        specs: 'crispy-paginator.spec.js',
        vendor: [
          'bower_components/angular/angular.min.js',
          'bower_components/angular-mocks/angular-mocks.js',
          'bower_components/lodash/dist/lodash.min.js',
        ],
        keepRunner: true,
      }
    },
    concat: {
      dist: {
        files: {
          '.tmp/concat.js': [
            'crispy-paginator.js',
            'templates.js',
          ]
        }
      }
    },
    ngmin: {
      dist: {
        src: '.tmp/concat.js',
        dest: '.tmp/ngmin.js'
      }
    },
    uglify: {
      dist: {
        files: {
          'dist/crispy-paginator.min.js': '.tmp/ngmin.js'
        }
      }
    },
    clean: {
      dist: '.tmp/',
    },
  });

  grunt.loadNpmTasks('grunt-contrib-jshint');
  grunt.loadNpmTasks('grunt-angular-templates');
  grunt.loadNpmTasks('grunt-contrib-jasmine');
  grunt.loadNpmTasks('grunt-ngmin');
  grunt.loadNpmTasks('grunt-contrib-uglify');
  grunt.loadNpmTasks('grunt-contrib-clean');
  grunt.loadNpmTasks('grunt-contrib-concat');

  grunt.registerTask('test', ['jshint', 'ngtemplates', 'jasmine']);
  grunt.registerTask('build', ['jshint', 'ngtemplates', 'concat', 'ngmin', 'uglify', 'clean']);
};
