Angular crispy paginator
========================

[![Build Status](https://travis-ci.org/ondrowan/angular-crispy-paginator.svg?branch=master)](https://travis-ci.org/ondrowan/angular-crispy-paginator)


Installation
------------

* [Bower](http://bower.io): `bower install angular-crispy-paginator`
* [npm](https://www.npmjs.org): `npm install angular-crispy-paginator`

Alternatively, you can download archives from [releases page](https://github.com/ondrowan/angular-crispy-paginator/releases).

Next step is to include `crispy-paginator.min.js` _after_ Angular and Lodash, since they are both mandatory dependencies.

```html
<script src="angular.min.js"></script>
<script src="lodash.min.js"></script>
...
<script src="crispy-paginator.min.js"></script>
```

Finally, add `crispy-paginator` as dependency to your application:

```javascript
angular.module('yourapp', [
  ...
  'crispy-paginator',
]);
```


Usage
-----

The simplest possible scenario is to provide just current page and total number of pages:

```javascript
$scope.currentPage = 2;
$scope.totalPages = 10;
```

```html
<crispy-paginator current-page="currentPage" total-pages="totalPages"></crispy-paginator>
```

Changing of actual elements is up to parent scope depending on values in `currentPage` and `totalPages`.


Settings
--------

Application-wise defaults can be set inside `config` block:

```javascript
app.config(function (CrispyPaginatorProvider) {
  CrispyPaginatorProvider.setTemplateUrl('path/to/template.html');
});
```

Currently supported settings:

* `setTemplateUrl` / `template-url` - sets template url (dun dun dun)
* `setVisiblePages` / `visible-pages` - number of pages that are visible at a time
* `setUseBoundaryLinks` / `use-boundary-links` - sets whether "First" and "Last" links should be used or not
* `setAlwaysShowBoundaryPages` / `always-show-boundary-pages` - sets if first and last pages should be shown at all times. In example, if set to true, `10 11 12` will be shown as `1 ... 10 11 12 ... 100`.

Default settings are:

```javascript
templateUrl = 'crispy-paginator.tpl.html'
visiblePages = 10
useBoundaryLinks = true
alwaysShowBoundaryPages = false
```
